//	Copyright (c) 1982 Dyadic Systems Limited	
#define MAXRANK		15	// causes circular include problems if	
				// defined in pocket.h			

#define APLBUSY (AplBusy())

//	Macros which may be overridden by machine.h	

#ifdef	SYSTEM_V
#define	BELL
#endif	// SYSTEM_V 

#ifdef	SYSTEM_III
#define	BELL
#endif	// SYSTEM_III 

#ifndef	VOLATILE
#define	VOLATILE	volatile
#endif	// VOLATILE 

#ifdef	XAPL
#define	GUI 1
#endif	// XAPL 

#ifdef	WINDOWS3
#define	GUI 1
#endif	// WINDOWS3 

#ifndef	GUI
#define	GUI 0
#endif	// GUI 

#ifndef _CONSOLE
#define	_CONSOLE 0
#endif//_CONSOLE

#if	_CONSOLE
#	undef	GUI
#	define	GUI 0
#endif//_CONSOLE

#ifndef HAS_APLMON
#define HAS_APLMON 1
#endif//HAS_APLMON
#ifndef HAS_APLMON2
#define HAS_APLMON2 0
#endif//HAS_APLMON2

#ifndef HAS_OUTLINING
#define HAS_OUTLINING 1
#endif//HAS_OUTLINING

#ifndef HAS_SYNCOL
#define HAS_SYNCOL 1
#endif//HAS_SYNCOL

#if HAS_SYNCOL && !HAS_OUTLINING
#error HAS_SYNCOL requires HAS_OUTLINING (to do the syntax analysis)
#endif

#if HAS_UNICODE

#define  UNICODE 	// for WINDOWS
#define _UNICODE	// for WINDOWS

#define GSTR(name) 	L##name

#else

#define GSTR(name) 	name

#endif

#ifndef GPA			// WINCE has UNICODE GetProcAddress,
#define GPA(a)	(a)		// even UNICODE desktop windows has narrow GetProcAddress
#endif

#ifndef xxBIT
#define xxBIT		32	// if not set, 32 bit build
#endif

#ifndef	SIGTYPE			// the type of a signal-catcher routine	
#define	SIGTYPE		void	// ANSI says void, SYS V says void, older 
#endif	/* SIGTYPE			 *//* versions may need int		*/

#ifndef	SIGHANDSHAKE
#define SIGHANDSHAKE	SIGTERM
#endif	// SIGHANDSHAKE 

#ifdef	DALIGN			// If the machine requires double 	
#define	WSDALIGN	1	// alignment, define WorkSpace		
#endif//DALIGN			// alignment also.

#ifndef P4ALIGN			// No Pentium 4 alignment needed
#define P4ALIGN
#endif //P4ALIGN

#ifndef MAXUNSIGNED		// some machines don't support unsigned	
#define MAXUNSIGNED	~0	// well - if so set to the maximum	
#endif	/* MAXUNSIGNED		 *//* possible default (signed) integer	*/

#ifndef MAXSTRONG
#define MAXSTRONG	10
#endif	// MAXSTRONG 

#ifndef MAXFCHARS		// max characters in full path name	
#define MAXFCHARS	FILENAME_MAX	// get from stdio.h
#endif	// MAXFCHARS 

#ifndef	SMLOGSIZ		// characters in session manager's log	
#define	SMLOGSIZ	81920	// 10240 until 1994-07-08
				// 40960 until 1998-09-15
#endif	// SMLOGSIZ 

#ifndef	PFKBUFSIZ		// characters in pfkey buffer		
#if HAS_UNICODE
#define	PFKBUFSIZ	10240
#else
#define	PFKBUFSIZ	2048
#endif
#endif	// PFKBUFSIZ 

#ifndef	GREENBUFSIZ		// characters in input line buffer	
#if HAS_UNICODE
#define	GREENBUFSIZ	10240
#else
#define	GREENBUFSIZ	4096
#endif
#endif	// GREENBUFSIZ 

#ifndef	HISTBUFSIZ		// characters in input history buffer	
#if HAS_UNICODE
#define	HISTBUFSIZ	10240
#else
#define	HISTBUFSIZ	2048
#endif
#endif	// HISTBUFSIZ 

#ifndef	CUTBUFSIZ		// characters in cut / paste buffer	
#define	CUTBUFSIZ	256
#endif	// CUTBUFSIZ 

#if	!defined(PACKED)
#	define	PACKED(something)	something
#endif//!defined(PACKED)

#if 	!defined(LIBCALL)
#define LIBCALL
#endif

#if 	!defined(STACKCALL)
#define STACKCALL
#endif

#if 	!defined(CRTIMP)
#define CRTIMP
#endif

#if 	!defined(FORCEINLINE)
#define FORCEINLINE
#endif

#if	defined(_APL_IME) && !AP_BUILD

#define ggetenv	_wgetenv

#else

#define ggetenv	w_shad_getenv

#	ifndef	getenv	// enable enviroment defaults and overrides 
#		include <stdlib.h>	// get real definition before ...
#		define getenv	shad_getenv
		char * LIBCALL shad_getenv(const char *);
#	endif //getenv 

#endif//defined(APL_IME)

#ifndef	DINT

#define DINT		APLLONG	// 4 byte default integers		
#define dint		l	// access via hold.l			
#define dintp		lp	// ptr via ptr.lp			
#define dint_t		aplint32// use long type

#endif	// DINT 

#ifndef APLIPTR

#if 64 == xxBIT

#define APLIPTR		APLDOUB	// 8 byte pointer storage
#define iptr_t		aplint64// use 64bit type

#elif 32 == xxBIT

#define APLIPTR		APLLONG	// 4 byte pointer storage
#define iptr_t		aplint32// use long type

#endif // xxBIT

#define iptr		_iptr	// access via hold.iptr			
#define iptrp		_iptrp	// ptr via ptr.lp			

#endif // APLIPTR


#define	dzero		d	// comparison of doubles against 0	

#if	BYTE3210		// VAX, NS32000 etc			
#elif	BYTE2301
#elif	BYTE1032
#elif	BYTE0123
#else
#	define BYTE0123	1	// M68000, Z8000 etc			
#endif

//	which short in a double contains the exponent			
//	see the code for testnan()					
#ifndef	EXP_SHORT
#	ifdef	BYTE0123
#		define	EXP_SHORT	0
#	endif	// BYTE0123 

#	ifdef	BYTE3210
#		define	EXP_SHORT	3
#	endif	// BYTE3210 
#endif	// EXP_SHORT 

#ifndef	DRAND			// consider whether this is needed (see	
#ifndef	BYTE0123		// the code of rand.c). must be defined	
#define	DRAND			// if bytes in strange order		
#endif	// BYTE0123 
#endif	// DRAND 

#ifdef	BELL
#ifndef	TIMEOV			// Consider whether this is needed (see	
#endif	/* TIMEOV			 *//* tty.c). unlikely to be required	*/
#endif	// BELL 

#ifndef	HERTZ			// This gives the frequency of the CPU	
				// line (interrupt) clock.  You may	
				// need to define it if it is not	
				// already defined in a system include	
				// file.  It will default to 60.  It is	
				// used in cpu() (in util.c) to convert	
#endif	/* HERTZ			 *//* clock ticks to msec for quadAI[2].	*/

#ifdef	BSD
#define strrchr		rindex	// string(3) difference			
#define strchr		index	// string(3) difference			
#define LS_C			// always use "ls -C" on BSD machines	
#endif	// BSD 

#ifndef	WORDALIGN		// used in scan.c & quadvfi.c		
#define	WORDALIGN 	int
#endif	// WORDALIGN 

// some machines e.g. CADSOFT can't cope with some register types	

#ifndef	REGDOUB
#define REGDOUB 	register double
#endif	// REGDOUB 

#ifndef	REG_UNION
#define REG_UNION	register union
#endif	// REG_UNION 

/* define REG_VFN if machine can't handle register void function pointers
e.g.	#define	REG_VFN void
or	#define	REG_VFN register
or	#define	REG_VFN	int
*/

#ifndef	REG_VFN
#define	REG_VFN		register void
#endif	// REG_VFN 

#ifndef	REG_IFN
#define	REG_IFN		register int
#endif	// REG_IFN 

// some machines (SPS7) get pointer comparisons wrong			

#ifndef	NULLP
#define	NULLP(x)	((x) == 0)
#endif	// NULLP 

#ifndef	CMPTR
#define	CMPTR(l, op, r)	((l) op (r))
#endif	// CMPTR 

// some machines e.g. ZILOG cant cope if brk() fails 

#ifdef	BRK_ERR			// This defines the action to be taken	
				// if brk(2) ever fails.  On Zilog and	
				// Tower XP define it as syserror(2),	
				// otherwise UNIX will crash when brk()	
#endif	/* BRK_ERR			 *//* fails.				*/

// derive standard value for OLD_DEPRECATED_MACHINETYPE 
// 	// cvc 20-02-2002, i'm going to hijack machinetype e for the WIN CE
// 		so that we can load CE workspaces in apl/w 9
//

#ifdef	Ieee
#	ifdef	BYTE3210
#		if defined(UNSINT) 	|| defined (WINCE)
#			ifdef	DALIGN
#			define	OLD_DEPRECATED_MACHINETYPE	0xf	// non known 
#			else//  
#			define	OLD_DEPRECATED_MACHINETYPE	0xe	// non known 
#			endif	// DALIGN 
#		else//  
#			ifdef	DALIGN
#			define	OLD_DEPRECATED_MACHINETYPE	0xd	// non known 
#			else//  
#			define	OLD_DEPRECATED_MACHINETYPE	0xc	// Nat Semi, Intel 
#			endif	// DALIGN 
#		endif	// UNSINT 
#	else//  
#		ifdef	UNSINT
#			ifdef	DALIGN
#			define	OLD_DEPRECATED_MACHINETYPE	0xb	// sps9 (Ridge) 
#			else//  
#			define	OLD_DEPRECATED_MACHINETYPE	0xa	// 6150		
#			endif	// DALIGN 
#		else//  
#			ifdef	DALIGN
#			define	OLD_DEPRECATED_MACHINETYPE	0x9	// Sun4, HP800	
#			else//  
#			define	OLD_DEPRECATED_MACHINETYPE	0x8	// most common	
#			endif	// DALIGN 
#		endif	// UNSINT 
#	endif	// BYTE3210 
#else//  
#	ifdef	BYTE3210
#		ifdef	UNSINT
#			ifdef	DALIGN
#			define	OLD_DEPRECATED_MACHINETYPE	0x7	// non known 
#			else//  
#			define	OLD_DEPRECATED_MACHINETYPE	0x6	// non known 
#			endif	// DALIGN 
#		else//  
#			ifdef	DALIGN
#			define	OLD_DEPRECATED_MACHINETYPE	0x5	// non known 
#			else//  
#			define	OLD_DEPRECATED_MACHINETYPE	0x4	// Vax 
#			endif	// DALIGN 
#		endif	// UNSINT 
#	else//  
#		ifdef	UNSINT
#			ifdef	DALIGN
#			define	OLD_DEPRECATED_MACHINETYPE	0x3	// non known 
#			else//  
#			define	OLD_DEPRECATED_MACHINETYPE	0x2	// non known 
#			endif	// DALIGN 
#		else//  
#			ifdef	DALIGN
#			define	OLD_DEPRECATED_MACHINETYPE	0x1	// Gould 
#			else//  
#			define	OLD_DEPRECATED_MACHINETYPE	AARGH!	// none allowed 
#			endif	// DALIGN 
#		endif	// UNSINT 
#	endif	// BYTE3210 
#endif	// Ieee 


// note that all real (still extant) machines have the Ieee bit set
// so I can use it to distinguish ARCH from OLD_DEPECATED_MACHINETYPE.
// I need to do this because early 64 bit component headers mistakenly
// used OLD_DEPECATED_MACHINETYPE.

// Also, whilst I think it horrible to do it, using a bit to indicate that
// integer alignment is required means that all architectures will have at least// one bit set. This is because the only machines that don't have this as a
// requirement are Intel/AMD and they are little endian.

// The thing that requires the distinction is that the GUI structures built into// pockets have a different alignment on Intel than anything else. The Linux
// port uses the edges of the gcc compiler to support the same alignment as
// Microsoft generates. The ARM port cannot because the hardware itself can't
// access the data on those boundaries.

// derive new architecture type for WS_VER 7 onwards 

#define	ARCH_LITTLE		0x80
#define	ARCH_DEXTEND		0x40
#define	ARCH_64BIT		0x20
#define	ARCH_DALIGN		0x10
#define	ARCH_MACH		0x08	// not an ARCH this one is MACHINETYPE
#define	ARCH_UNICODE		0x04
#define	ARCH_IALIGN		0x02	//need this to distingush ARM from INTEL
#define ARCH_SPARE		0x01

#if	defined(BYTE3210)
#	define	ARCH_BIT_7	ARCH_LITTLE
#else
#	define	ARCH_BIT_7	0
#endif

#if	defined(LONGDOUBLES)
#	define	ARCH_BIT_6	ARCH_DEXTEND
#else
#	define	ARCH_BIT_6	0
#endif

#if	64 == xxBIT
#	define	ARCH_BIT_5	ARCH_64BIT
#else
#	define	ARCH_BIT_5	0
#endif

#if	defined(DALIGN)
#	define	ARCH_BIT_4	ARCH_DALIGN
#else
#	define	ARCH_BIT_4	0
#endif

#define		ARCH_BIT_3	0

#if	defined(UNICODE)
#	define	ARCH_BIT_2	ARCH_UNICODE
#else
#	define	ARCH_BIT_2	0
#endif

#if	defined(IALIGN)
#	define	ARCH_BIT_1	ARCH_IALIGN
#else
#	define	ARCH_BIT_1	0
#endif

#if	0
#	define	ARCH_BIT_0	ARCH_SPARE
#else
#	define	ARCH_BIT_0	0
#endif

#if	defined(PACKED_STRUCT)
#else //defined(PACKED_STRUCT)
#	define PACKED_STRUCT
#endif//defined(PACKED_STRUCT)

#if	defined(PACKED_ENUM)
#else //defined(PACKED_ENUM)
#	define PACKED_ENUM
#endif//defined(PACKED_ENUM)

#if	defined(PACKED)
#else //defined(PACKED)
#	define PACKED(something) something
#endif//defined(PACKED)

#define NONAMELESSUNION

#if PROFILING

#define parse_setjmp(vp)        setjmp((int*)vp)
#define parse_longjmp(vp,r)     longjmp((int*)vp,r)

typedef int parse_jmp_buf[1024];

#else

#if !defined(PARSE_JMP_BUF_SIZE)
#define PARSE_JMP_BUF_SIZE	64
#endif

#if !defined(PARSE_JMP_BUF_TYPE)
#define PARSE_JMP_BUF_TYPE	void *
#endif

typedef PARSE_JMP_BUF_TYPE parse_jmp_buf[PARSE_JMP_BUF_SIZE];

#endif // PROFILING


#if	defined(__NT__)

#undef PP0CHK

#define MK_FP32(p)	(p)

#if	WINCE
#	define DefFrameProc(h,i,m,w,l)	DefWindowProc(h,m,w,l)
#endif//WINCE

#	define MoveTo(h,x,y)		MoveToEx(h,x,y,0);
#define SetWindowOrg(h,x,y)	SetWindowOrgEx(h,x,y,0);
#define SetWindowExt(h,x,y)	SetWindowExtEx(h,x,y,0);
#define SetViewportOrg(h,x,y)	SetViewportOrgEx(h,x,y,0);
#define SetViewportExt(h,x,y)	SetViewportExtEx(h,x,y,0);
#define OffsetViewportOrg(h,x,y)	OffsetViewportOrgEx(h,x,y,0);
#define SetBrushOrg(h,x,y)	SetBrushOrgEx(h,x,y,0);

#endif	// __NT__ 

#if defined(DOSWIN)
#	define	DIRDELIM	'\\'
#	define	PATHDELIM	';'
#	define 	PATHDELIMSTR 	GSTR(";")
#else
#	define	DIRDELIM	'/'
#	define	PATHDELIM	':'
#	define 	PATHDELIMSTR 	GSTR(":")
#endif


// automatic help file creation
#undef  HELPSTRING
#define HELPSTRING(a,b) 

#define	ARCH		\
	(		\
	ARCH_BIT_7	\
|	ARCH_BIT_6	\
|	ARCH_BIT_5	\
|	ARCH_BIT_4	\
|	ARCH_BIT_3	\
|	ARCH_BIT_2	\
|	ARCH_BIT_1	\
|	ARCH_BIT_0	\
	)

#if !defined(WARN_W64)
#define WARN_W64
#endif // WARN_W64


#if !defined PRINTF_MINT	// printf for intmax_t
#	define PRINTF_MINT	GSTR("%ji")
#endif 

#if !defined PRINTF_MUNS	// printf for uintmax_t
#	define PRINTF_MUNS	GSTR("%ju")
#endif 

#define CHARS_ARE_UNSIGNED 	1

#include <apltypes.h>

extern void *zalloc(size_t size); // hate this here, probably needs zalloc.h
//extern gstr wstrdup(const gchar *s1);		// "

extern gchar * LIBCALL w_shad_getenv(const gchar *envname);


#if UNIX && HAS_UNICODE

// wide character externals that we will have to implement on most
// unix systems

// functions implemented in gfns.c :
extern int _waccess(const gchar *filename, int mode);
extern gchar *_wgetenv(const gchar *envname);
extern gchar *_wmktemp(gchar *template);
extern int _wrename(const gchar *old, const gchar *new);
extern int _wunlink(const gchar *filename);

// functions not yet implemented :
extern CRTIMP int LIBCALL _wopen(const wchar_t *filename,int flag, ...);
extern CRTIMP int LIBCALL _wsopen(const wchar_t *filename,int flag,int, ...);
extern CRTIMP int LIBCALL wcsicmp(const wchar_t *s1,const wchar_t *s2);
extern CRTIMP int LIBCALL wcsicmp(const wchar_t *s1,const wchar_t *s2);
extern CRTIMP wchar_t * LIBCALL _wgetcwd(wchar_t *buf,int len);
extern void *_wopendir(wchar_t *);
extern wchar_t * _wcserror(unsigned short err);
extern wchar_t *_wctime(int *mtime);

#endif

#if defined(WINDOWS3) && !_MANAGED && !UNIX && !AP_BUILD

extern void __declspec(noreturn) LIBCALL cover_exit(int);
#define exit	cover_exit	// use our exit function (will call library exit)

#endif

#define NATIVE(a) (char *)(a)

#if HAS_ONLINEHELP
#define HID(str)	GSTR(str)
#else
#define HID(str)	(0)
#endif //HAS_ONLINEHELP

#define WIDEN(x) GSTR(x)
#define __WDATE__ WIDEN(__DATE__)

#define STRINGIFY(a)	#a
#define TOSTRING(a)	STRINGIFY(a)

#if !defined(GSTAT)
#define GSTAT struct stat
#endif

//	Copyright (c) 1982 Dyadic Systems Limited	
