
// assume version 8 ie NT or WIN95 and Watcom 10.5
// means one segment and all pointers are nice and easy
// this means that the F in FVP FCP doesn't mean FAR

#include <malloc.h>
#include <apl.h>
#include <support.h>

#define Su (sizeof(MEMORYUNS))
typedef size_t RDWRFN(int, void *, size_t);

typedef UCP 	FCP;
typedef void *			FVP;
typedef FVP *			FVPP;

// the functions data_read, data_write are covers
// that look like read() and write().
// The "pipe" argument is ignored
// data_size() looks like data_write() but only counts the size
// writing will be a two pass operation

static FCP data_ptr;

static void data_seek(FVP fvp)
	{
	data_ptr = fvp;
	}

static  size_t data_read(int pipe, void * vp,  size_t len)
	{
	memcpy((FVP)vp, data_ptr, len);
	data_ptr += len;
	return len;
	}

static  size_t data_write(int pipe, void *vp,  size_t len)
	{
	memcpy(data_ptr, (FVP)vp, len);
	data_ptr += len;
	return len;
	}

static  size_t data_size(int pipe, void *vp,  size_t len)
	{
	data_ptr += len;
	return len;
	}


static BOUND d_fromapl(void)
	{
	BOUND value;

	(void)data_read(0, &value, sizeof(value));
	return value;
	}

static void d_toapl(RDWRFN *rdwrfn, MEMORYUNS value)
	{
	(void)(*rdwrfn)(0, &value, sizeof(value));
	}

static void *w_malloc(size_t nwords)
	{
	return malloc(nwords * sizeof(MEMORYUNS));
	}

ARRAY *getA(FVP fvp)		// get(possibly nested) array from apl	
	{
	FVPP fvpp = (FVPP)fvp;
	unsigned rank;
	BOUND *shape;
	ARRAY *array, **ptr;
	size_t nwords;			// number of words remaining to read	
	ARRAY temp;

	data_seek(*fvpp);		// position pointer to start of data

	if((nwords = d_fromapl()) == 0)	// read word count		
		return(0);		// left arg omitted		
	fields(&temp) = d_fromapl();	// read type/rank/eltype	

#ifdef	DALIGN
	if(temp.eltype == APLDOUB)
		{
		MEMORYUNS pad, *tmp;

		pad = (temp.rank+2)%DOUBWORDS;
		tmp = w_malloc(--nwords+pad);
		array = (ARRAY *)(tmp+(DOUBWORDS-pad)%DOUBWORDS);
		}
	else
#endif	// DALIGN 
	array = w_malloc(--nwords);	// adjust word count &		
					// allocate space for array	
	shape = &(array->shape[0]);	// take pointer to shape	
	array->length = nwords;		// fill in array length		
	fields(array) = fields(&temp);	// and type/rank/eltype		

	nwords -= 2;			// decr words to be read	

	if(array->type == SIMPLE)
		(*data_read)(0, shape, Su * nwords);// simple array 
	else
		{
		rank = array->rank;
		(*data_read)( 0, shape, Su * rank);// read shape	
		nwords -= rank;			// ... and decr count	

		/*	now recursively read in sub-arrays and
			install pointers in parent array.
		*/
		for(ptr = data(array, ARRAY *); nwords--;)
			*ptr++ = getA(&data_ptr);
		}
	return array;			// return pointer to array	
	}


static void sub_putA(RDWRFN *rdwrfn, ARRAY *array)
	{
	ARRAY **ptr;
	size_t rank, nwords;

	if(array == 0)
		d_toapl(rdwrfn, 0);		// null result		
	else
		{
		d_toapl(rdwrfn, nwords = array->length+1);// pipe length word 
		if(array->type == SIMPLE)
			(*rdwrfn)( 0, &fields(array), Su * (nwords-2));
		else
			{
			rank = array->rank;
			// pipe and shape 
			(*rdwrfn)( 0, &fields(array), Su * (rank+1));
			nwords -= rank+1+2;	// words remaining	
			// recursively put each subarray		
			for(ptr = data(array, ARRAY *); nwords--;)
				sub_putA(rdwrfn, *ptr++);
			}
		}
	}

typedef struct Chain
	{
	struct Chain	*next;
	FVP		data;
	} CHAIN;

static CHAIN *head;

void freeA(void)
	{
	CHAIN *this;
	CHAIN *next;

	for
		(
		next = head
	,	head = 0
	;	this = next
	;	next = this->next
	,	free(this->data)
	,	free(this)
		);
	}

static void add_chain(FVP data)
	{
	CHAIN *this = malloc(sizeof(CHAIN));

	this->next = head;
	head = this;
	this->data = data;
	}

void putA(FVP fvp, ARRAY *ptr)
	{
	FVPP fvpp = (FVPP)fvp;
	FVP data;
	size_t size_of_data;

	// pass one size the data
	data_seek(0);
	sub_putA(data_size, ptr);
	size_of_data = data_ptr - (FCP)0;

	// allocate some space for it
	data = malloc(size_of_data);
	
	// pass two fill it in
	data_seek(data);
	sub_putA(data_write, ptr);

	// tell APL where it is
	*fvpp = data;
	add_chain(data);		// so we can free it later
	}
