#if defined(VERSION_H_INCLUDED)
#else //VERSION_H_INCLUDED
#define	VERSION_H_INCLUDED	1

#define	VERSION0		12	// major revision level
#define	VERSION1		1	// defines functionality
#define	RELNO			1	// bug fix level	// 09-11-2009
#define	WS_VER0	        	0x0C
#define	WS_VER1			0x05	// 2009-09-17

#if 64==xxBIT
	#if HAS_UNICODE
		#define DYALOG_PERSONAL_DIR        "Dyalog APL-64 12.1 Unicode Files"
	#else
		#define DYALOG_PERSONAL_DIR        "Dyalog APL-64 12.1 Files"
	#endif
#else
	#if HAS_UNICODE
		#define DYALOG_PERSONAL_DIR        "Dyalog APL 12.1 Unicode Files"
	#else
		#define DYALOG_PERSONAL_DIR        "Dyalog APL 12.1 Files"
	#endif
#endif

#define WIDE_DYALOG_PERSONAL_DIR	WIDEN(DYALOG_PERSONAL_DIR)

#define CURRENT_VERSION		((WS_VER0<<8) | WS_VER1)

#define	VERSIONAB_DOT	 	VERSION0.VERSION1			//  A.B
#define	VERSIONABC_DOT	 	VERSION0.VERSION1.RELNO			//  A.B.C

#define	VERSIONAB_DOT_STR 	TOSTRING(VERSIONAB_DOT)			// "A.B"
#define	VERSIONABC_DOT_STR 	TOSTRING(VERSIONABC_DOT)		// "A.B.C"

#define	VERSIONAB_COMMA	 	VERSION0,VERSION1			//  A,C
#define	VERSIONABC_COMMA 	VERSION0,VERSION1,RELNO			//  A,B,C

#define	VERSIONAB_COMMA_STR 	TOSTRING(VERSIONAB_COMMA)		// "A,B"
#define	VERSIONABC_COMMA_STR 	TOSTRING(VERSIONABC_COMMA)		// "A,B,C"


#if defined SVN_REVISION 

// SVN_REVISION is only defined when building resources and dos_date.c

#define	VERSIONABCD_DOT	 	VERSION0.VERSION1.RELNO.SVN_REVISION	//  A.B.C.D
#define	VERSIONABCD_COMMA 	VERSION0,VERSION1,RELNO,SVN_REVISION	//  A,B,C,D

#define	VERSIONABCD_COMMA_STR 	TOSTRING(VERSIONABCD_COMMA)		// "A,B,C,D"
#define	VERSIONABCD_DOT_STR 	TOSTRING(VERSIONABCD_DOT)		// "A.B.C.D"

#endif

// Leave WS_VERS A.5 and A.6 spare in case we need to make an emergency
// fix to 10.0 workspaces that involves bumping the WS_VER - GRS.

#if	GUI
#	if	defined(XAPL)
#		define SUFFIX	"X"
#	elif	defined(MAINWIN)
#		define SUFFIX	"M"
#	elif	WINE
#		define SUFFIX	"WINE"
#	elif	defined(WINCE)
#		define SUFFIX	"P"
#	elif	defined(WINDOWS3)
#		define SUFFIX	"W"
#	endif
#else //GUI
#	if	defined(WINDOWS3)
#		if	1 == _CONSOLE
#			define SUFFIX	"C"
#		elif	2 == _CONSOLE
#			define SUFFIX	"A"
#		endif //_CONSOLE
#	else  //defined(WINDOWS3)
#		define	SUFFIX	"S"
#	endif //defined(WINDOWS3)
#endif//GUI

#if 64==xxBIT
#define WSUFFIX "-64"
#define WIDE_WSUFFIX GSTR("-64")
#else
#define WSUFFIX
#define WIDE_WSUFFIX
#endif


#if defined(WINCE)
	#define	     PRODUCT_NAME	 "Pocket APL"
	#define WIDE_PRODUCT_NAME WIDEN("Pocket APL")
#else
	#define	     PRODUCT_NAME	 "Dyalog APL/"        SUFFIX       WSUFFIX
	#define WIDE_PRODUCT_NAME  WIDEN("Dyalog APL/") WIDEN(SUFFIX) WIDE_WSUFFIX
#endif

#if HAS_UNICODE
#define UNICODESTR	" Unicode"
#else
#define UNICODESTR
#endif

#if HAS_UNICODE
#define EDITIONSTR	"Unicode"
#else
#define EDITIONSTR	"Classic"
#endif


#define SQ_REGISTRY_SECTION 	GSTR("SOFTWARE\\Insight\\Sqapl")



extern char  *version_string(char *fmt);
extern gchar *gversion_string(gchar *fmt);

#endif//VERSION_H_INCLUDED

